#include-once

; Author: Mars (AutoIt.de)
; Datum:  01.05.2014

; Umrechnung vom Dezimalsystem ins Binrsystem und zurck.

Global $a_[256], $b_[256], $c_[11111112], $__bStartup = False

; <Func>-----------------------------------------------------------------------|
; Verlngert einen String aus Dualzahlen, bis seine Lnge durch 8 Teilbar ist  |
; und somit ins AscII-System umgerechnet werden kann. Fr $bUnCap = False      |
; wird eine Ergnzung angefgt, fr $bUnCap = True wird diese wieder entfernt  |
; -----------------------------------------------------------------------------|
Func _BinCap8($sBin, $bUnCap = False)
	Local Static $aLeft[8] = ['00000000', '0000001', '000001', '00001', '0001','001','01','1']
	If Not $bUnCap Then Return $aLeft[Mod(StringLen($sBin), 8)] & $sBin
	For $i = 0 To 7 Step 1
		If StringLeft($sBin, StringLen($aLeft[$i])) = $aLeft[$i] Then Return StringTrimLeft($sBin, StringLen($aLeft[$i]))
	Next
EndFunc

; <Func>--------------------------------------------------|
; Wandelt eine Dualzahl in eine Dezimalzahl um            |
; --------------------------------------------------------|
Func _BinToDec($s)
	Local $l = StringLen($s)
	Return $l<9?$c_[$s]:$l<17?$c_[StringTrimRight($s,8)]*256+$c_[StringRight($s,8)]:$l<25?$c_[StringTrimRight($s,16)]*65536+$c_[StringRight(StringTrimRight($s,8),8)]*256+ $c_[StringRight($s,8)]:BitShift($c_[StringTrimRight($s,24)],-24)+$c_[StringRight(StringTrimRight($s,16),8)]*65536+$c_[StringRight(StringTrimRight($s,8),8)]*256+$c_[StringRight($s,8)]
EndFunc

; <Func>--------------------------------------------------|
; Ermittelt eine Dualzahl (0101) aus einer Dezimalzahl    |
; Die Dezimalzahl muss kleiner als 2^31 sein              |
; --------------------------------------------------------|
Func _DecToBin($d)
    Return $d<256?$a_[$d]:$d<65536?$a_[$d/256]&$b_[BitAND($d,255)]:$d<16777216?$a_[$d/65536]&$b_[BitAND($d/256,255)]&$b_[BitAND($d,255)]:$a_[BitShift($d,24)]&$b_[BitAND($d/65536,255)]&$b_[BitAND($d/256,255)]&$b_[BitAND($d,255)]
EndFunc

; <Func>--------------------------------------------------|
; Initialisiert die DecToBin UDF                          |
; --------------------------------------------------------|
Func _DecToBinStartup()
	If $__bStartup Then Return
	$__bStartup = True
	Local $t = DllStructCreate('char[64]'), $p = _
	DllStructGetPtr($t), $hDll = DllOpen('msvcrt.dll')
    For $i = 0 To 255 Step 1
		DllCall($hDll, 'ptr:cdecl', '_i64toa', 'int64', _
		$i, 'ptr', $p, 'int', 2)
        $a_[$i] = DllStructGetData($t, 1)
        $b_[$i] = StringRight('0000000' & $a_[$i], 8)
		$c_[$a_[$i]] = $i
    Next
	DllClose($hDll)
EndFunc
